
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>javascript继承机制 / iVAN</title>

    <meta name="description" content="javascript继承机制   澄清在先,Java 和Javascript是雷锋和雷峰塔的关系.Javascript原名Mocha,当时还叫做LiveScript,创造者是Brendan Eich,现任Mozilla公司首席技术官. 1994年,历史上第一个比较成熟的网络浏览器--Navigator0.9版诞生在网景公司(Netscape),极为轰动. 但是,Navigator0.9只能用来浏览,不具备与访问者交互的能力,比如,用户提交一个数据表单,如果表单为空,浏览器是无法判断的,只能直接提交给服务器端,再把空值的错误返">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">javascript继承机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> 　　澄清在先，Java  和Javascript是雷锋和雷峰塔的关系。Javascript原名Mocha，当时还叫做LiveScript，创造者是Brendan  Eich，现任Mozilla公司首席技术官。</p>
<p>　　1994年，历史上第一个比较成熟的网络浏览器——Navigator0.9版诞生在网景公司(Netscape)，极为轰动。</p>
<p>　　但是，Navigator0.9只能用来浏览，不具备与访问者交互的能力，比如，用户提交一个数据表单，如果表单为空，浏览器是无法判断的，只能直接提交给服务器端，再把空值的错误返回，让用户重新填写，这样显然是低效率和浪费资源的。</p>
<p>　　这个时候，对于正处于技术革新最前沿的  Netscape，开发一种实用的客户端脚本语言来处理这些问题变得必要起来，于是，这个任务落到了工程师Brendan  Eich身上。他觉得吧，木必要设计得很复杂，只要能搞定一些简单操作就够了，比如判断用户有没有填写表单。</p>
<p>　　1994年正是面向对象编程(object-oriented  programming)的兴盛时代，C++是最流行的语言，而Java语言的1.0版即将于次年推出，Brendan Eich难免受其影响，  他想将Javascript里面所有的数据类型看做是对象(object)，这一点与Java非常相似。但是，他马上就遇到了一个难题，到底要不要设计”继承”机制呢?</p>
<p>　　二、继承的来源和演化</p>
<p>　　1、采用new关键字生成实例</p>
<p>　　处理表单验证这样简单功能脚本语言显然是不需要”继承”机制的，然而如果Javascript里面都是对象，就需要有一种办法来把所有对象联系起来。最后，Brendan  Eich还是设计了”继承”。只是，他并没有引入”类”(class)的概念，因为一旦有了”类”，Javascript就是一种完整的面向对象编程语言了，</p>
<p>　　这好像有点太正式了，与设计初衷也远了，同时增加了初学者的入门难度。</p>
<p>　　参照到C++和Java语言都使用new命令来生成实例：</p>
<p>　　C++这样写：</p>
<p>　　ClassName *object = new ClassName(param);</p>
<p>　　Java这样写：</p>
<p>　　Foo foo = new Foo();</p>
<p>　　那么，也可以把new命令引入了Javascript，用来从原型对象生成一个实例对象。但是，Javascript中没有”类”的话，怎样表示原型对象呢?</p>
<p>　　依然是参照C++和Java使用new命令时，都会调用”类”的构造函数(constructor)。Brendan  Eich简化了设计，在Javascript语言中，new命令后面跟的是构造函数，不再是类。</p>
<p>　　我们举个例子来说，现在有一个叫做WD构造函数，表示前端开发(web-developper)对象的原型。</p>
<p>　　function WD(skill){</p>
<p>　　this.skill = skill;</p>
<p>　　}</p>
<p>　　对这个构造函数使用new关键字，就会生成一个前端开发对象的实例。</p>
<p>　　var WD1 = new WD(’html’);</p>
<p>　　console.log(WD1.skill); // html</p>
<p>　　在构造函数中的this关键字，它其实代表的是新创建的实例对象。</p>
<p>　　2、new 出来对象的缺陷</p>
<p>　　采用new关键字，用构造函数生成实例对象无法共享属性和方法。</p>
<p>　　比如，在WD对象的构造函数中，设置一个实例对象的共有属性skill。</p>
<p>　　function WD(skill){</p>
<p>　　this.skill = skill;</p>
<p>　　this.sex = ’男’;</p>
<p>　　}</p>
<p>　　然后，生成两个实例对象：</p>
<p>　　var WD1 = new WD(’html’);</p>
<p>　　var WD2 = new WD(’css’);</p>
<p>　　这两个对象的skill属性是独立的，修改其中一个，不会影响到另一个。</p>
<p>　　WD1.skill= ’Javascript’;</p>
<p>　　console.log(WD2.skill);//“css”，不受WD1的影响</p>
<p>　　每一个实例对象，都有自己的属性和方法的副本。这不仅无法做到数据共享，也是极大的资源浪费。</p>
<p>　　3、引入prototype属性</p>
<p>　　为了实现属性和方法的共享，Brendan Eich决定为构造函数设置一个prototype属性。</p>
<p>　　这个属性包含一个对象(以下简称”prototype对象”)，所有实例对象需要共享的属性和方法，都放在这个对象里面;那些不需要共享的属性和方法，就放在构造函数里面。</p>
<p>　　实例对象一旦创建，将自动引用prototype对象的属性和方法。也就是说，实例对象的属性和方法，分成两种，一种是本地的，另一种是引用的。</p>
<p>　　还是以WD构造函数为例，现在用prototype属性进行改写：</p>
<p>　　function WD(skill){</p>
<p>　　this.skill = skill;</p>
<p>　　}</p>
<p>　　WD.prototype = { sex : ’男’ };</p>
<p>　　var WD1 = new WD(’html’);</p>
<p>　　var WD2 = new WD(’css’);</p>
<p>　　console.log(WD1.sex); // 男</p>
<p>　　console.log(WD2.sex); // 男</p>
<p>　　现在，sex属性放在prototype对象里，是两个实例对象共享的。只要修改了prototype对象，就会同时影响到两个实例对象。</p>
<p>　　WD.prototype.sex = ’女’;</p>
<p>　　console.log(WD1.sex); //女</p>
<p>　　console.log(WD2.sex); // 女</p>
<p>　　由于所有的实例对象共享同一个prototype对象，那么从外界看起来，prototype对象就好像是实例对象的原型，而实例对象则好像”继承”了prototype对象一样。这就是Javascript继承机制的设计思想。</p>
<p>　　三、构造函数如何实现继承</p>
<p>　　现在有一个”MED”对象的构造函数(MED:Marketing Experience Design,营销体验设计)</p>
<p>　　function MED(){</p>
<p>　　this.aim = "营销体验设计";</p>
<p>　　}</p>
<p>　　依然是”WD”对象的构造函数，</p>
<p>　　function WD(skill,sex){</p>
<p>　　this.skill = skill;</p>
<p>　　this.sex = sex;</p>
<p>　　}</p>
<p>　　怎样才能使”WD”继承”MED”呢?</p>
<p>　　1. apply绑定构造函数实现</p>
<p>　　最简单的方法，大概就是使用call或apply方法，将父对象的构造函数绑定在子对象上，也就是在子对象构造函数中加一行：</p>
<p>　　function WD(skill,sex){</p>
<p>　　MED.apply(this, arguments);</p>
<p>　　this.skill = skill;</p>
<p>　　this.sex = sex;</p>
<p>　　}</p>
<p>　　var WD1 = new WD("Html","男");</p>
<p>　　console.log(WD1.aim); // "营销体验设计"</p>
<p>　　2. prototype模式实现</p>
<p>　　我们通常的做法是使用prototype属性。如果”WD”的prototype对象，指向一个MED的实例，那么所有”WD”的实例，就能继承MED了。</p>
<p>　　WD.prototype = new MED();//我们将WD的prototype对象指向一个MED的实例。</p>
<p>　　WD.prototype.constructor = WD;</p>
<p>　　var WD1 = new WD("Html","男");</p>
<p>　　console.log(WD1.aim); // 营销体验设计</p>
<p>　　这句</p>
<p>　　WD.prototype = new MED();</p>
<p>　　相当于完全删除了prototype 对象原先的值，然后赋予一个新值。那么第二行又是什么意思呢?</p>
<p>　　WD.prototype.constructor = WD;</p>
<p>　　原来，任何一个prototype对象都有一个constructor属性，指向它的构造函数。也就是说，WD.prototype  这个对象的constructor属性，是指向WD的。</p>
<p>　　我们在前一步已经删除了这个prototype对象原来的值，所以新的prototype对象没有constructor属性，需要我们手动加上去，否则后面的”继承链”会出问题。这就是第二行的意思。</p>
<p>　　注意，这是很重要的一点，编程时务必要遵守，下文都遵循这一点，即如果替换了prototype对象，</p>
<p>　　o.prototype = {};</p>
<p>　　那么，下一步必然是为新的prototype对象加上constructor属性，并将这个属性指回原来的构造函数。</p>
<p>　　o.prototype.constructor = o;</p>
<p>　　3. 从prototype直接继承实现</p>
<p>　　由于MED对象中，不变的属性都可以直接写入MED.prototype。所以，我们也可以让WD()跳过  MED()，直接继承MED.prototype。</p>
<p>　　现在，我们先将MED对象改写：</p>
<p>　　function MED(){ }</p>
<p>　　MED.prototype.skill = "MED";</p>
<p>　　然后，将WD的prototype对象指向MED的prototype对象，这样就完成了继承。</p>
<p>　　WD.prototype = MED.prototype;</p>
<p>　　WD.prototype.constructor = WD;</p>
<p>　　var WD1 = new WD("Html","男");</p>
<p>　　console.log(WD1.skill); // MED</p>
<p>　　与前一种方法相比，这样做的优点是效率比较高(不用执行和建立MED的实例了)，比较省内存。缺点是  WD.prototype和MED.prototype现在指向了同一个对象，那么任何对WD.prototype的修改，都会反映到MED.prototype。</p>
<p>　　所以，上面这一段代码其实是有问题的。请看第二行</p>
<p>　　WD.prototype.constructor = WD;</p>
<p>　　这一句实际上把MED.prototype对象的constructor属性也改掉了!</p>
<p>　　console.log(MED.prototype.constructor); // WD</p>
<p>　　4. 利用一个空对象作为中介来实现</p>
<p>　　由于”直接继承prototype”存在上述的缺点，所以可以利用一个空对象作为中介。</p>
<p>　　var F = function(){};</p>
<p>　　F.prototype = MED.prototype;</p>
<p>　　WD.prototype = new F();</p>
<p>　　WD.prototype.constructor = WD;</p>
<p>　　F是空对象，所以几乎不占内存。这时，修改WD的prototype对象，就不会影响到MED的prototype对象。</p>
<p>　　console.log(MED.prototype.constructor); // MED</p>
<p>　　5.利用 prototype模式的封装函数</p>
<p>　　我们将上面的方法，封装成一个函数，便于使用。</p>
<p>　　function extend(Child, Parent) {</p>
<p>　　var F = function(){};</p>
<p>　　F.prototype = Parent.prototype;</p>
<p>　　Child.prototype = new F();</p>
<p>　　Child.prototype.constructor = Child;</p>
<p>　　}</p>
<p>　　使用的时候，方法如下</p>
<p>　　extend(WD,MED);</p>
<p>　　var WD1 = new WD("Html","男");</p>
<p>　　console.log(WD1.aim); // 营销体验设计</p>
<p>　　这个extend函数就是YUI库如何实现继承的方法。</p>
<p>　　6. 拷贝继承实现</p>
<p>　　上面是采用prototype方式来实现继承。其实既然子对象会拥有父对象的属性和方法，我们直接采用”拷贝”方法也可以达到效果。简单说，如果把父对象的所有属性和方法，拷贝进子对象，不也能够实现继承吗?</p>
<p>　　首先，还是把MED的所有不变属性，都放到它的prototype对象上。</p>
<p>　　function MED(){}</p>
<p>　　MED.prototype.aim = "营销体验设计";</p>
<p>　　然后，再写一个函数，实现属性拷贝的目的。</p>
<p>　　function extendCopy(Child, Parent) {</p>
<p>　　var p = Parent.prototype;</p>
<p>　　var c = Child.prototype;</p>
<p>　　for (var i in p) {</p>
<p>　　c[i] = p[i];</p>
<p>　　}</p>
<p>　　}</p>
<p>　　这个函数的作用，就是将父对象的prototype对象中的属性，一一拷贝给Child对象的prototype对象。</p>
<p>　　使用的时候，这样写：</p>
<p>　　extendCopy(WD, MED);</p>
<p>　　var WD1 = new WD("Html","男");</p>
<p>　　console.log(WD1.aim); // 营销体验设计</p>
<p>　　四、”非构造函数”的如何实现继承</p>
<p>　　比如，现在有一个对象，叫做”MED”–营销体验设计。</p>
<p>　　var MED = {</p>
<p>　　aim:’营销体验设计’</p>
<p>　　}</p>
<p>　　还有一个对象，叫做”前端开发”。</p>
<p>　　var WD ={</p>
<p>　　skill:’html’</p>
<p>　　}</p>
<p>　　请问怎样才能让”前端开发”去继承”营销体验设计”，就是说，我怎样才能生成一个”营销体验设计的前端开发”对象?</p>
<p>　　这里要注意，这两个对象都是普通对象，不是构造函数，无法使用构造函数方法实现”继承”。</p>
<p>　　1、object()方法</p>
<p>　　Json格式的发明者Douglas Crockford，提出了一个object()函数，可以做到这一点。</p>
<p>　　function object(o) {</p>
<p>　　function F() {}</p>
<p>　　F.prototype = o;</p>
<p>　　return new F();</p>
<p>　　}</p>
<p>　　这个object()函数，其实只做一件事，就是把子对象的prototype属性，指向父对象，从而使得子对象与父对象连在一起。</p>
<p>　　使用的时候，第一步先在父对象的基础上，生成子对象：</p>
<p>　　var WD = object(MED);</p>
<p>　　然后，再加上子对象本身的属性：</p>
<p>　　WD.skill = ’html’;</p>
<p>　　这时，子对象已经继承了父对象的属性了。</p>
<p>　　console.log(WD.aim); //营销体验设计</p>
<p>　　2、浅拷贝</p>
<p>　　除了使用”prototype链”以外，还有另一种思路：把父对象的属性，全部拷贝给子对象，也能实现继承。</p>
<p>　　下面这个函数，就是在做拷贝：</p>
<p>　　function LightCopy(p) {</p>
<p>　　var c = {};</p>
<p>　　for (var i in p) {</p>
<p>　　c[i] = p[i];</p>
<p>　　}</p>
<p>　　//c.uber = p;</p>
<p>　　return c;</p>
<p>　　}</p>
<p>　　使用的时候，这样写：</p>
<p>　　var WD = LightCopy(MED);</p>
<p>　　WD.aim = ’前端开发’;</p>
<p>　　但是，这样的拷贝有一个问题。那就是，如果父对象的属性等于数组或另一个对象，那么实际上，子对象获得的只是一个内存地址，而不是真正拷贝，因此存在父对象被篡改的可能。</p>
<p>　　请看，现在给MED添加一个”技能”属性，它的值是一个数组。</p>
<p>　　MED.skills = [’‘html’’,’css’,’Javascript’];</p>
<p>　　通过LightCopy()函数，WD继承了MED。</p>
<p>　　var WD = LightCopy(MED);</p>
<p>　　然后，我们为WD的”技能”添加一个属性：</p>
<p>　　WD.skills.push(’teamwork’);</p>
<p>　　发生了什么事?MED的”技能”也被篡改了!</p>
<p>　　console.log(WD.skills); //‘html’,’Javascript’,’css’,’teamwork’</p>
<p>　　console.log(MED.skills); //‘html’,’Javascript’,’css’,’teamwork’</p>
<p>　　所以，LightCopy()只是拷贝基本类型的数据，我们把这种拷贝叫做”浅拷贝”。这是早期jQuery实现继承的方式。</p>
<p>　　3、深拷贝</p>
<p>　　所谓”深拷贝”，就是能够实现真正意义上的数组和对象的拷贝。它的实现并不难，只要递归调用”浅拷贝”就行了。</p>
<p>　　function deepCopy(p, c) {</p>
<p>　　var c = c || {};</p>
<p>　　for (var i in p) {</p>
<p>　　if (typeof p[i] === ’object’) {</p>
<p>　　c[i] = (p[i].constructor === Array) ? [] : {};</p>
<p>　　deepCopy(p[i], c[i]);</p>
<p>　　} else {</p>
<p>　　c[i] = p[i];</p>
<p>　　}</p>
<p>　　}</p>
<p>　　return c;</p>
<p>　　}</p>
<p>　　使用的时候这样写：</p>
<p>　　var WD = deepCopy(MED);</p>
<p>　　现在，给父对象加一个属性，值为数组。然后，在子对象上修改这个属性：</p>
<p>　　MED.skills = [’‘html’’,’css’,’Javascript’];</p>
<p>　　WD.skills.push(’teamwork’);</p>
<p>　　这时，父对象就不会受到影响了。</p>
<p>　　console.log(WD.skills); //‘html’,’css’,’Javascript’,’teamwork’</p>
<p>　　console.log(MED.skills); //‘html’,’css’,’Javascript’</p>
<p>　　目前，jQuery库使用的就是这种继承方法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 23:55:11</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%b1%9e%e6%80%a7/" title="属性">属性</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e5%ae%9e%e4%be%8b/" title="实例">实例</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/prototype/" title="prototype">prototype</a>, <a href="https://www.iamivan.net/tag/prototype%e9%97%ae%e9%a2%98%e3%80%82/" title="prototype问题。">prototype问题。</a>, <a href="https://www.iamivan.net/tag/prototype%e5%b1%9e%e6%80%a7/" title="prototype属性">prototype属性</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>javascript继承机制的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNkEyp.html" rel="bookmark">Javascript教程&colon;重温Javascript继承机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章简介:重温Javascript继承机制. 上段时间,团队内部有过好几次几次给力的分享,这里对西风师傅分享的继承机制稍作整理一下,适当加了写口语化的描述,留作备案. 一.讲个故事吧 澄清在先,Java 和Javascript是雷锋和雷峰塔的关系.Javascript原名Mocha,当时还叫做LiveScript,创造者是Brendan Eich,现任Mozilla公司首席技术官. 1994年,历史上第一个比较成熟的网络浏览器--Navigator0.9版诞生在网景公司(Netscape),极为			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0N600z.html" rel="bookmark">javascript继承机制实例详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了javascript继承机制.分享给大家供大家参考.具体分析如下: 初学javascript一般很难理解Javascript语言的继承机制它没有&quot;子类&quot;和&quot;父类&quot;的概念,也没有&quot;类&quot;(class)和&quot;实例&quot;(instance)的区分,全靠一种很奇特的&quot;原型链&quot;(prototype chain)模式,来实现继承. 我花了很多时间,学习这个部分,还做了很多笔记.但是都属于强行记忆,无法从根本上理解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgED9Ez.html" rel="bookmark">Javascript继承机制的设计思想分享&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我一直很难理解Javascript语言的继承机制. 它没有&quot;子类&quot;和&quot;父类&quot;的概念,也没有&quot;类&quot;(class)和&quot;实例&quot;(instance)的区分,全靠一种很奇特的&quot;原型链&quot;(prototype chain)模式,来实现继承. 我花了很多时间,学习这个部分,还做了很多笔记.但是都属于强行记忆,无法从根本上理解. 直到昨天,我读到法国程序员Vjeux的解释,才恍然大悟,完全明白了Javascript为什么这样			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXxE9lp.html" rel="bookmark">阿里巴巴技术文章分享 Javascript继承机制的实现&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript作为一门脚本语言,在设计之初并没有考虑到面向对象的特性.即便到了当今这个遍布现代浏览器的年代,各种Javascript 框架/库如雨后春笋般地疯狂生长,Javascript中连个 class 关键字都没有.如果你要编写一个类,你还得借助于function,至于继承.重载什么的,就别奢望了. 可是,没有继承,日子怎么过啊?难道把所有的共有逻辑都拷贝一遍,实现最低级的代码复用? 答案当然是--NO,所以,我们要自己实现继承! 目标 最关键的目标当然是继承--子类自动拥有父类的所有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0PP6AM.html" rel="bookmark">Javascript继承机制的设计思想</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我一直很难理解Javascript语言的继承机制. 它没有&quot;子类&quot;和&quot;父类&quot;的概念,也没有&quot;类&quot;(class)和&quot;实例&quot;(instance)的区分,全靠一种很奇特的&quot;原型链&quot;(prototype chain)模式,来实现继承. 我花了很多时间,学习这个部分,还做了很多笔记.但是都属于强行记忆,无法从根本上理解. 直到昨天,我读到法国程序员Vjeux的解释,才恍然大悟,完全明白了Javascript为什么这样			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEOq1z.html" rel="bookmark">Javascript继承机制的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript作为一门脚本语言,在设计之初并没有考虑到面向对象的特性.即便到了当今这个遍布现代浏览器的年代,各种Javascript 框架/库如雨后春笋般地疯狂生长,Javascript中连个 class 关键字都没有.如果你要编写一个类,你还得借助于function,至于继承.重载什么的,就别奢望了. 可是,没有继承,日子怎么过啊?难道把所有的共有逻辑都拷贝一遍,实现最低级的代码复用? 答案当然是--NO,所以,我们要自己实现继承! 目标 最关键的目标当然是继承--子类自动拥有父类的所有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44a3Jz.html" rel="bookmark">Javascript 继承机制的实现&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				选定基类后,就可以创建它的子类了.是否使用基类完全由你决定.有时,你可能想创建一个不能直接使用的基类,它只是用于给子类提供通用的函数.在这种情况下,基类被看作抽象类. 尽管ECMAScript并没有像其他语言那样严格地定义抽象类,但有时它的确会创建一些不允许使用的类.通常,我们称这种类为抽象类. 创建的子类将继承超类的所有属性和方法,包括构造函数及方法的实现.记住,所有属性和方法都是公用的,因此子类可直接访问这些方法.子类还可添加超类中没有的新属性和方法,也可以覆盖超类中的属性和方法. 4.2.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxEAyPp.html" rel="bookmark">JavaScript 继承机制的实现&lpar;待续&rpar;&lowbar;js面向对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.对象冒充 原理:构造函数使用this关键字给所有属性和方法赋值(即采用类声明的构造函数方式). 因为构造函数只是一个函数,所以可使ClassA的构造函数成为ClassB的方法,然后调用它.ClassB就会收到ClassA的构造函数中定义的属性和方法. 例如: 下面方式定义的ClassA和ClassB: 复制代码 代码如下: function ClassA(sColor){ this.color=sColor; this.sayColor=function(){ alert(this.colo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLdQxvp.html" rel="bookmark">javascript继承机制的实现示例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我花了很多时间,学习这个部分,还做了很多笔记.但是都属于强行记忆,无法从根本上理解. 如何创建一个类 假设有给叫Person的类如下:  代码如下 复制代码 var Person = function(name, age) {     this.name = name;     this.age = age; } Person.prototype.getName = function() {     return this.name; } 如上:Person代表地球上所有的人,每个人都有这两个基			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7Q1RM.html" rel="bookmark" class="title">有哪些提升单页滚动体验的高级技巧？</a>
					<div>
						  扁平化已成主流,简约风随处可见,全景大图+单页设计也已经成为了高大上的代名词.随便结合几种大势所趋的设计手法似乎就能成就一个逼格爆棚的好网站,打磨细节似乎已不必要,真的是这样么?细节里面蹲满了魔鬼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo88jM.html" rel="bookmark" class="title">UNIX下ORACLE数据库的创建</a>
					<div>
						oracle|unix|创建|数据|数据库 创建数据库虽说是一件很平常的工作,在ORACLE的参考文档中也有一定的描述,但现实中确有很多人都不会,一方面是因为平时很少有这样的机会让你去做,而真有了这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPyQ1z.html" rel="bookmark" class="title">三级下拉框连动的数据库版</a>
					<div>
						'三级下拉框连动''数据库:'location'表1 loaction  所在地表'   字段'   loactionid'   loactionname 名字'表2 district  所在的地区表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV2xkz.html" rel="bookmark" class="title">&period;NET编程中使用旧有的COM组件</a>
					<div>
						编程 本文以使用W3 JMail为例 1. 生成包含Metadata(元数据)的DLL 在jmail的安装目录,键入以下命令,将生成jmail_dotnet.dll TlbImp jmail.dll  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyRk8p.html" rel="bookmark" class="title">android中如何判断edittext中数据为空</a>
					<div>
						今天写了一个简单的记忆便笺小程序,但是却发现在判断添加数据不能为空的时候,自己的代码总是不起作用. String titleStr = addtitle()() String contentStr = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA90XM.html" rel="bookmark" class="title">Illustrator&sol;AI图层间的复制粘贴问题</a>
					<div>
						我以前还知道怎么回事,但是昨天再用的时候就搞不清楚了.我是想把下一层的路径复制在上一层上,但是要位置也一样的,我记得是直接按shift+F 就好了,但是昨天怎么也弄不上去,依然是会复制在原层上,我事先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1K5Ez.html" rel="bookmark" class="title">JPA设计模式系列一 DAO Pattern in JPA</a>
					<div>
						作为JavaEE5 规范一部分的JPA,已经有众多的实现,比如:Hiberante,TopLink, EclipseLink和OpenJPA 等许多ORM框架.JPA不仅仅应用于EJB3中,你也可以应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAjVOb.html" rel="bookmark" class="title">第十二章-异常处理与程序调试（一）&lpar;2&rpar;</a>
					<div>
						12.1.1.3 整数异常 整数异常都是从一个EIntError类派生的,但程序运行中引发的总是它的子类:EDivByZero,ERangeError,EIntOverFlow. 表12.2 整数异常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Nkmgz.html" rel="bookmark" class="title">Android开发入门（十八）文件 18&period;3如何选择最佳的存储方式</a>
					<div>
						之前的几篇文章描述了在Android应用中存储数据的主要三种方式:SharedPreferences,内部存储和外部 SD卡存储.究竟在你的应用中采用那种方式呢?下面有一些建议: 1. 如果你有键值对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE2DNb.html" rel="bookmark" class="title">在Word 2010中使用后台打印文档功能</a>
					<div>
						通过使用后台打印功能,可以实现在打印文档的同时继续编辑该Word 2010文档,否则只能在完成打印任务后才能进行编辑. 在Word 2010中启用后台打印功能的步骤如下所述: 第1步,打开Word 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7Rlnb.html" rel="bookmark" class="title">走上开放之路&colon; &period;NET开发人员的J2EE基础&lpar;下&rpar;</a>
					<div>
						相关文章:走上开放之路: .NET 开发人员的 J2EE 基础(上) .NET 和 J2EE 应用模型:理解它们的区别 要理解 J2EE 应用程序体系结构的基本概念,第一步是确定如何将现有的 ASP. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR4Jaz.html" rel="bookmark" class="title">CSS实现定位元素居中的方法</a>
					<div>
						  绝对定位元素的居中实现 如果要问如何CSS实现绝对定位元素的居中效果,很多人心里已经有答案了. 兼容性不错的主流用法是: CSS Code复制内容到剪贴板 .element { width: 60 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1EBqz.html" rel="bookmark" class="title">wps和office的区别</a>
					<div>
						  WPS与Office是两款使用量非常大的办公软件,作为办公软件的新起之秀,WPS与经典老牌办公软件Office的区别在哪里呢?关于这个问题,相信也是很多网友都想知道了.因此,今天小编就从软件名称和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw7OYb.html" rel="bookmark" class="title">Photoshop给女性照片添加梦幻光线效果</a>
					<div>
						  效果图: 原图: 先用修复画笔将皮肤瑕疵进行修复 二.新建灰色图层,模式柔光,用加深/减淡工具对皮肤过度不均匀的地方进行调整,再盖印图层. 三.利用曲线命令将黄色眼影及绿色眼影进行调整 四.利用曲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badZ92z.html" rel="bookmark" class="title">新浪微博如果申请大屏幕失败会收到通知吗？</a>
					<div>
						  申请大屏幕时会留下您的联系邮箱,审核的结果均会通过邮件告知,拒绝会告知拒绝的理由.如未收到可能是被邮箱拦截了,请查看邮箱的垃圾箱.或者登录大屏幕的首页,点击&quot;我的大屏幕&quot;也看查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZyQVb.html" rel="bookmark" class="title">脚本-oracle10&period;2&period;0&period;4升级到11&period;2&period;0&period;1相关问题</a>
					<div>
						问题描述 oracle10.2.0.4升级到11.2.0.1相关问题 进行升级之后,11g的新特性只读表使用不成功,在升级后需要执行什么内置脚本吗? 解决方案 是不是11g没有升级完全,升到11.2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kXaPM.html" rel="bookmark" class="title">织梦5 7 curl-如何使用CURL获取织梦5&period;7后台登录后的cookie值</a>
					<div>
						问题描述 如何使用CURL获取织梦5.7后台登录后的cookie值 $curl = curl_init(); $cookie_jar = tempnam('./tmp','cookie'); curl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrZwKM.html" rel="bookmark" class="title">oracle-LINUX下使用&period;sql脚本，不知道是那里写错了！求解答！</a>
					<div>
						问题描述 LINUX下使用.sql脚本,不知道是那里写错了!求解答! 进入oracle用户后获取DBA权限运行.sql文件sqlplus / as sysdba @create_user.sql以下是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZGYYM.html" rel="bookmark" class="title">安卓 开发-安卓软件开发的安装问题</a>
					<div>
						问题描述 安卓软件开发的安装问题 为什么在安装安卓ADT的时候一直出现&quot;暂挂起&quot;状态,我的是WIN7系统,32位					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDYgdz.html" rel="bookmark" class="title">代码审查时，发现功能实现的原因，而不仅仅是挑毛病（转）</a>
					<div>
						对于很多公司来说,代码审查是开发人员日常工作中的重要环节.通过代码审查,可以及早发现项目中存在的问题.促进同事之间的沟通与交流,并且可以在讨论中迸发出智慧的火花.但要想成功实施代码审查却并不是一件轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkelBOb.html" rel="bookmark" class="title">基于云计算平台的随机森林算法的研究与实现</a>
					<div>
						基于云计算平台的随机森林算法的研究与实现 于延  王建华 随着网络时代海量数据的日渐普及,从中挖掘出有价值的信息成为当今社会的研究热点.本文针对构建随机森林的数据挖掘算法,提出了基于海量数据的分布式可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAlewp.html" rel="bookmark" class="title">OceanBase由于合并操作导致事务被杀死的情况。</a>
					<div>
						       OceanBase是一台内存数据库,兼容MySQL协议以及SQL协议,拥有跟内存数据库一样的属性:所有的数据都需要先写入到内存里面,但是并不会立刻落盘写入到存储里面,需要等一次合并操作, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKAPEb.html" rel="bookmark" class="title">Linux定时自动备份数据库并上传至FTP的脚本</a>
					<div>
						适用于使用lnmp环境下定时自动备份网站和mysql数据库并上传至FTP:  代码如下 复制代码 •#!/bin/bash •MYSQL_USER=root •MYSQL_PASS=root •FTP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDerwWb.html" rel="bookmark" class="title">Kafka&plus;Storm&plus;HDFS整合实践</a>
					<div>
						在基于Hadoop平台的很多应用场景中,我们需要对数据进行离线和实时分析,离线分析可以很容易地借助于Hive来实现统计分析,但是对于实时的需求Hive就不合适了.实时应用场景可以使用Storm,它是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YYdoz.html" rel="bookmark" class="title">Python 目录操作（转）</a>
					<div>
						在Python中,文件操作主要来自os模块,主要方法如下: os.listdir(dirname):列出dirname下的目录和文件os.getcwd():获得当前工作目录os.curdir:返回当前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRElkp.html" rel="bookmark" class="title">首个虚拟运营商号码公开17097910004 平均一秒一个电话</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 首个虚拟运营商号码公开170979 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7q0AM.html" rel="bookmark" class="title">Android开发之完成登陆界面的数据保存回显操作实例&lowbar;Android</a>
					<div>
						本文实例讲述了Android开发之完成登陆界面的数据保存回显操作.分享给大家供大家参考,具体如下: LoginActivity.java: package com.example.login; imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0W6wz.html" rel="bookmark" class="title">javafx-使用JavaFX如何实现  点击按钮选择本地文件上传到服务器</a>
					<div>
						问题描述 使用JavaFX如何实现 点击按钮选择本地文件上传到服务器 请问大神 使用JavaFX如何实现 点击按钮选择本地文件上传到服务器 JavaFX貌似没有这个UI控件 求帮忙! 类似如下图片所示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8XRZp.html" rel="bookmark" class="title">为抵制微软&OpenCurlyDoubleQuote;黑屏&rdquo;寻找法律依据</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 2008年的微软&quot;黑屏事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdQ1Bb.html" rel="bookmark" class="title">农业大数据民企敢为先</a>
					<div>
						&quot;现阶段农业的主要矛盾仍是供需问题,农业供给侧改革将是今后一个时期农业农村发展的重头戏.希望民营企业通过充分运用大数据技术,找到农业供给侧和需求侧的错位之处,发现市场空白.&quot; &q ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
